package com.ichangzuo.core.security.exception;

import com.ichangzuo.common.exception.AccountDeletedException;
import com.ichangzuo.common.exception.AccountLockedException;
import com.ichangzuo.common.result.ResultCode;
import com.ichangzuo.common.util.ResponseUtils;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.AuthenticationEntryPoint;
import org.springframework.stereotype.Component;

import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.IOException;

/**
 * 认证异常处理
 *
 * @author haoxr
 * @since 2.0.0
 */
@Component
public class MyAuthenticationEntryPoint implements AuthenticationEntryPoint {
        @Override
    public void commence(HttpServletRequest request, HttpServletResponse response, AuthenticationException authException) throws IOException, ServletException {
        int status = response.getStatus();
        if (status == HttpServletResponse.SC_NOT_FOUND) {
            // 资源不存在
            ResponseUtils.writeErrMsg(response, ResultCode.RESOURCE_NOT_FOUND);
        } else {
            if(authException instanceof BadCredentialsException){
                // 用户名或密码错误
                ResponseUtils.writeErrMsg(response, ResultCode.USERNAME_OR_PASSWORD_ERROR);
            }
            else if(authException.getCause() instanceof AccountLockedException){
                // 账户被冻结
                ResponseUtils.writeErrMsg(response, ResultCode.USER_ACCOUNT_LOCKED);
            }
            else if(authException.getCause() instanceof AccountDeletedException){
                // 账户已注销
                ResponseUtils.writeErrMsg(response, ResultCode.USER_ACCOUNT_DELETED);
            }
            else {
                // 未认证或者token过期
                ResponseUtils.writeErrMsg(response, ResultCode.TOKEN_INVALID);
            }
        }
    }
}
